#ifndef FLYFM_FAVORITEPLACESMANAGERPROXY_H
#define FLYFM_FAVORITEPLACESMANAGERPROXY_H

#include <QObject>
#include <QWeakPointer>
#include <QDBusInterface>

#include <flyfm/favoriteplace.h>

namespace FlyFM
{

class FavoritePlacesManagerProxy : public QObject
{
    Q_OBJECT
public:
    explicit FavoritePlacesManagerProxy(QWeakPointer<QDBusInterface> interface, QObject *parent = nullptr);

    QList<FavoritePlace> favoritePlaces();
    void addFavoritePlace(const FavoritePlace &place);
    void removeFavoritePlace(const FavoritePlace &place);
    FLYFM_VFS_EXPORT int freeNetworkPlaceId();

signals:
    void favoritePlaceAdded(const FlyFM::FavoritePlace &place);
    void favoritePlaceRemoved(const FlyFM::FavoritePlace &place);

private slots:
    void slotFavoritePlaceAdded(const FlyFM::FavoritePlace &place);
    void slotFavoritePlaceRemoved(const FlyFM::FavoritePlace &place);

private:
    QWeakPointer<QDBusInterface> m_interface;
    QList<FavoritePlace> m_places;
    bool m_cached;
};

} // namespace FlyFM

#endif // FLYFM_FAVORITEPLACESMANAGERPROXY_H
